/**
   Implement this task graph using four threads
   and fork/join, with the forks and joins inside
   of the thread tasks. This will not deadlock
   (but it does have race conditions).

              task1
             /     \
            /       \
       task2         task3
            \       /
             \     /
              task4
*/
public class TaskGraph_v1_v2
{
   private static Thread t4 = null;

   public static void main(String[] args)
   {
      final Task<Integer,Integer> task1 = new Task<>(1, 1, 2);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 1);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 3);
      final Task<Integer,Integer> task4 = new Task<>(4, 4, 2);

      final Thread t1 = new Thread(task1);

      final Thread t2 = new Thread(
                          ()->{try{ t1.join();   // maybe
                                    task2.run();
                                  }catch(InterruptedException e){} }
                                  );

      final Thread t3 = new Thread(
                          ()->{try{ t1.join();   // maybe
                                    task3.run();
                                    t4.start();  // fork
                                  }catch(InterruptedException e){} }
                                  );

                   t4 = new Thread(
                          ()->{try{ t2.join();   // maybe
                                    t3.join();
                                    task4.run();
                                  }catch(InterruptedException e){} }
                                  );

      t1.start(); // fork
      t2.start(); // fork
      t3.start(); // fork
   }
}
